#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#include "buzzer.h"


volatile unsigned char buzzer_on;
volatile unsigned char tick1, buz_timer;


ISR(TIMER1_OVF_vect)
{
	TCNT1 = 65536 - 625;

	if( buzzer_on ) {
		tick1++;
		if( buz_timer > tick1 )	BUZZER_OUT &= ~(1 << BUZZER);
		else {
			if( (buz_timer * 2) > tick1 )	BUZZER_OUT |= 1 << BUZZER;
			else	tick1 = 0;
		}
	}
	else	BUZZER_OUT |= 1 << BUZZER;
}

void timer1_init(void)
{
	TCCR1A = 0x00;
	TCCR1B = 0x04;
	TCCR1C = 0x00;
	TCNT1 = 65536 - 625;
	TIMSK |= 0x04;
}

void buzzer_init(void)
{
	BUZZER_DDR = 1 << BUZZER;
	BUZZER_OUT |= 1 << BUZZER;

	timer1_init();

	buzzer_on = 0;
	tick1 = 0;
	buz_timer = 0;
}
