#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>

#include "Fnd.h"


#define SEG_OUT		PORTC
#define SEG_DDR		DDRC

#define DIG_OUT		PORTG
#define DIG_DDR		DDRG


volatile char fnd_flag;
volatile unsigned char cur_temp;


ISR(TIMER2_OVF_vect)
{
	char segment[11] = { 0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xD8, 0x80, 0x90 };
	static char digit = 0;

	TCNT2 = 256 - 125;

	DIG_OUT = 0x03;
	SEG_OUT = 0x00;

	if( fnd_flag ) {
		if( digit == 0 )		SEG_OUT = segment[cur_temp / 10];
		else if( digit == 1 )	SEG_OUT = segment[cur_temp % 10];
	}
	else {
		if( digit == 0 )		SEG_OUT = 0x89;
		else if( digit == 1 )	SEG_OUT = 0x88;
	}
	DIG_OUT &= ~(1 << digit);

	digit ^= 0x01;
}

void timer2_init(void)
{
	TCCR2 = 0x04;
	TCNT2 = 256 - 125;
	TIMSK |= 0x40;
}

void fnd_init(void)
{
	SEG_DDR = 0xFF;
	DIG_DDR = 0x03;
	DIG_OUT = 0x03;

	timer2_init();

	fnd_flag = 0;
	cur_temp = 0;
}
