#include <avr/io.h>
#include <util/delay.h>

#include "key.h"


#define KEY_IN	PINB
#define KEY_DDR	DDRB


volatile char key_flag;


unsigned char getkey(unsigned char keyin)
{
	unsigned char key;

	key_flag = 0;

	key = ~KEY_IN & 0x70;
	if( key ) {
		_delay_ms(5);
		key = ~KEY_IN & 0x70;
		if( key ) {
			if( key == 0x10 )		key = KEY_HOME;
			else if( key == 0x20 )	key = KEY_OUT;
			else if( key == 0x40 )	key = KEY_SLEEP;
		}
	}

	if( key && (key != keyin) )	key_flag = 1;

	return key;
}

void key_init(void)
{
	KEY_DDR &= ~0x70;
}
